unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ImgList, ExtCtrls, StdCtrls, Menus,DateUtils;

type
  TForm1 = class(TForm)
    report: TListView;
    ImageList1: TImageList;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Edit1: TMenuItem;
    Reload1: TMenuItem;
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Reload1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


type
    ppoznamka=^tpoznamka;
    tpoznamka=record
          den,mesic:word;
          text:string;
    end;
var
  Form1: TForm1;
  svatky:array [1..31,1..12] of string;
  ted,TVOJE_NAROZKY:tdate;
  poznamky:tlist;
  aktivni:boolean;
  POCET_VSE,VYSKA_OKNA,POCET_MINUL,POCET_AKTIV,SIRKA_POZNAMEK:integer;
  CAS_AKTIV:longint;

implementation

{$R *.DFM}

procedure nahraj_svatky(a:string);
var f:textfile;
    i,j:byte;
begin
     assignfile(f,a); reset(f);
     for j:=1 to 12 do for i:=1 to 31 do readln(f,svatky[i,j]);
     closefile(f);
end;

function incDay(a:tdatetime; b:integer):tdatetime;
var dr,dm,dd:word;
    ir,im,id:integer;
begin
     decodedate(a,dr,dm,dd);  ir:=dr; im:=dm; id:=dd;
     id:=id+b;
     while id<1 do begin
           dec(im); if (im<1) then begin dec(ir); im:=12; end;
           id:=id+MonthDays[IsLeapYear(ir),im];
     end;
     while id>MonthDays[IsLeapYear(ir),im] do begin
           id:=id-MonthDays[IsLeapYear(ir),im];
           inc(im); if (im>12) then begin inc(ir); im:=1; end;
     end;
     result:=encodedate(ir,im,id);
end;

function svatek(a:tdatetime):string;
var dr,dm,dd:word;
begin
     decodedate(a,dr,dm,dd);
     result:=svatky[dd,dm];
end;

procedure nahraj_poznamky(a:string);
var f:textfile;
    dm:integer;
    mezi_pozn:ppoznamka;
begin
     poznamky:=tlist.Create;
     assignfile(f,a);
     reset(f);
     readln(f,dm);
     while (dm>-1) do begin
           new(mezi_pozn);
           mezi_pozn.mesic:=dm;
           readln(f,mezi_pozn.den);
           readln(f,mezi_pozn.text);
           poznamky.Add(mezi_pozn);
           readln(f,dm);
     end;
     closefile(f);
end;

procedure nacti_nastaveni(a:string);
var f:textfile;
    s:string;
begin
     assignfile(f,a);
     {$I-}
     Reset(F);
     {$I+}
     if IOResult = 0 then begin
        readln(f);
        readln(f,POCET_VSE);
        readln(f);
        readln(f,VYSKA_OKNA);
        readln(f);
        readln(f,POCET_MINUL);
        readln(f);
        readln(f,POCET_AKTIV);
        readln(f);
        readln(f,SIRKA_POZNAMEK);
        readln(f);
        readln(f,CAS_AKTIV);
        readln(f);
        readln(f,s); TVOJE_NAROZKY:=strtodate(s);
     end else begin
        rewrite(f);
        writeln(f,'pocet dnu v celem seznamu');
        POCET_VSE:=367;
        writeln(f,POCET_VSE);
        writeln(f,'vyska okna');
        VYSKA_OKNA:=213;
        writeln(f,VYSKA_OKNA);
        writeln(f,'pocet uplynulych dnu');
        POCET_MINUL:=2;
        writeln(f,POCET_MINUL);
        writeln(f,'pocet dnu, ktere ktere aktivuji nevypnuti');
        POCET_AKTIV:=12;
        writeln(f,POCET_AKTIV);
        writeln(f,'sirka sloupce pro poznamky');
        SIRKA_POZNAMEK:=300;
        writeln(f,SIRKA_POZNAMEK);
        writeln(f,'cas automatickeho vypnuti bez poznamek [ms]');
        CAS_AKTIV:=10000;
        writeln(f,CAS_AKTIV);
        writeln(f,'tvoje narozeniny DD.MM.RRRR');
        TVOJE_NAROZKY:=strtodate('1.1.2000');
        writeln(f,TVOJE_NAROZKY);
     end;
     closefile(f);
end;

function najdi_poznamku(a:tDateTime):string;
var mezi_pozn:ppoznamka;
    i:integer;
    var dr,dm,dd:word;
begin
     result:='';
     decodedate(a,dr,dm,dd);
     for i:=0 to poznamky.Count-1 do begin
         mezi_pozn:=poznamky.Items[i];
         if ((mezi_pozn.den=dd) or (mezi_pozn.den=0)) and
            ((mezi_pozn.mesic=dm) or (mezi_pozn.mesic=0)) then begin
           if result='' then result:=mezi_pozn.text else
              result:=result+' | '+mezi_pozn.text;
         end;
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
    mezi_den:tlistitem;
    m_den:tdatetime;
    d:longint;
begin
     report.Items.Clear;
     nacti_nastaveni('setup.ini');
     d:=daysbetween(TVOJE_NAROZKY,now);
     statusbar1.Panels[0].Text:='U jsi proil '+inttostr(d) +' dn';
     statusbar1.Panels[0].Text:=statusbar1.Panels[0].Text+', co je piblin '+inttostr(d*24)+' hodin nebo '+inttostr(d*24*60)+' minut';

     form1.Height:=VYSKA_OKNA;
     report.Columns[3].width:=SIRKA_POZNAMEK;
     form1.Width:=SIRKA_POZNAMEK+205;
     timer1.Interval:=CAS_AKTIV;
     ted:=now;
     aktivni:=false;
     nahraj_svatky('svatky.ini');
     nahraj_poznamky('poznamky.ini');
     form1.caption:=FormatDateTime('"Dnes je" d. mmmm yyyy - dddd',ted);
     for i:=-POCET_MINUL to POCET_VSE-POCET_MINUL-1 do begin
         m_den:=incDay(ted,i);
         mezi_den:=report.items.Add;
         if i=0 then mezi_den.StateIndex:=0 else begin
            if ((dayofweek(m_den)-1) mod 6)=0 then mezi_den.StateIndex:=1 else
            mezi_den.StateIndex:=-1;
         end;
         mezi_den.SubItems:=tstringlist.Create;
         mezi_den.SubItems.Add(FormatDateTime('d.m.',m_den));
         mezi_den.SubItems.Add(svatek(m_den));
         mezi_den.SubItems.Add(najdi_poznamku(m_den));
         if (mezi_den.SubItems[2]<>'') and (i<(POCET_AKTIV-POCET_MINUL)) then aktivni:=true;
     end;
     if paramstr(1)= '-start' then
      if not aktivni then timer1.Enabled:=true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
     close;
end;

procedure TForm1.Edit1Click(Sender: TObject);
var dir:string;
begin
  getdir(0,dir);

  if dir[length(dir)]<>'\' then dir:=dir+'\';
  form1.Caption:=dir;
  winexec(PChar('notepad.exe '+dir+'poznamky.ini'),sw_show);
end;

procedure TForm1.Reload1Click(Sender: TObject);
begin
  form1.FormCreate(sender);
end;

end.
